scala.util.parsing.ast

# Binders

#### trait Binders extends AbstractSyntax with Mappable

This component provides functionality for enforcing variable binding during parse-time.

When parsing simple languages, like Featherweight Scala, these parser combinators will fully enforce the binding discipline. When names are allowed to be left unqualified, these mechanisms would have to be complemented by an extra phase that resolves names that couldn't be resolved using the naive binding rules. (Maybe some machinery to model `implicit` binders (e.g., `this` and imported qualifiers) and selection on a binder will suffice?)

Source
  Binders.scala

Linear Supertypes
Mappable, AbstractSyntax, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Binders
2. Mappable
3. AbstractSyntax
4. AnyRef
5. Any

Visibility

1. Public
2. All

### Type Members

1. #### abstract class BinderEnv extends AnyRef

   An environment that maps a `NameElement` to the scope in which it is bound.

2. #### trait BindingSensitive extends AnyRef

3. #### case class BoundElement[boundElement <: NameElement](el: boundElement, scope: Scope[boundElement]) extends NameElement with Proxy with BindingSensitive with Product with Serializable

   A `BoundElement` is bound in a certain scope `scope`, which keeps track of the actual element that `el` stands for.

4. #### trait Element extends Positional

   The base class for elements of the abstract syntax tree.

5. #### trait Mappable[T] extends AnyRef

6. #### trait Mapper extends AnyRef

7. #### trait NameElement extends Element

   The base class for elements in the AST that represent names {@see Binders}.

8. #### trait ReturnAndDo[T] extends AnyRef

   Returns a given result, but executes the supplied closure before returning.

9. #### class Scope[binderType <: NameElement] extends Iterable[binderType]

   A `Scope` keeps track of one or more syntactic elements that represent bound names.

10. #### class UnboundElement[N <: NameElement] extends NameElement

    A variable that escaped its scope (i.

11. #### class UnderBinder[binderType <: NameElement, elementT] extends Element with BindingSensitive

    Represents an element with variables that are bound in a certain scope.

### Abstract Value Members

1. #### abstract def UserNameElementIsMappable[t <: NameElement](self: t): Mappable[t]

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### object EmptyBinderEnv extends BinderEnv

7. #### implicit def ListIsMappable[t](xs: List[t])(implicit arg0: (t) ⇒ Mappable[t]): Mappable[List[t]]

   Definition Classes
     Mappable

8. #### implicit def NameElementIsMappable(self: NameElement): Mappable[NameElement]

9. #### implicit def OptionIsMappable[t](xs: Option[t])(implicit arg0: (t) ⇒ Mappable[t]): Mappable[Option[t]]

   Definition Classes
     Mappable

10. #### implicit def ScopeIsMappable[bt <: NameElement](scope: Scope[bt])(implicit arg0: (bt) ⇒ Mappable[bt]): Mappable[Scope[bt]]

11. #### implicit def StringIsMappable(s: String): Mappable[String]

    Definition Classes
      Mappable

12. #### object UnderBinder extends AnyRef

13. #### implicit def UnderBinderIsMappable[bt <: NameElement, st](ub: UnderBinder[bt, st])(implicit arg0: (bt) ⇒ Mappable[bt], arg1: (st) ⇒ Mappable[st]): Mappable[UnderBinder[bt, st]]

14. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

15. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

19. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### def return_[T](result: T): ReturnAndDo[T]

26. #### def sequence[bt <: NameElement, st](orig: List[UnderBinder[bt, st]])(implicit arg0: (st) ⇒ Mappable[st]): UnderBinder[bt, List[st]]

    If a list of `UnderBinder`s all have the same scope, they can be turned in to an `UnderBinder` containing a list of the elements in the original `UnderBinder`.

    If a list of `UnderBinder`s all have the same scope, they can be turned in to an `UnderBinder` containing a list of the elements in the original `UnderBinder`.

    The name `sequence` comes from the fact that this method's type is equal to the type of monadic sequence.

    Note

      `!orig.isEmpty` implies `orig.forall(ub => ub.scope eq orig(0).scope)`

27. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

28. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

29. #### def unsequence[bt <: NameElement, st](orig: UnderBinder[bt, List[st]])(implicit arg0: (st) ⇒ Mappable[st]): List[UnderBinder[bt, st]]

30. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

31. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

32. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from Mappable

### Inherited from AbstractSyntax

### Inherited from AnyRef

### Inherited from Any